<?php

namespace AppBundle\Service;

use AppBundle\Entity\User;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Component\Security\Core\Encoder\UserPasswordEncoderInterface;

/**
 * Agir sur les utilisateurs
 */
class UserManager
{
    protected $em;
    protected $passwordEncoder;
    /**
     * Search constructor.
     * @param EntityManagerInterface $em
     */
    public function __construct(EntityManagerInterface $em, UserPasswordEncoderInterface $passwordEncoder)
    {
        $this->em = $em;
        $this->passwordEncoder = $passwordEncoder;
    }

    public function createUser($username, $password, $nom, $prenom, $mail, $roles, $activated)
    {
        $user = new User();
        $user->setUsername($username);
        $user->setPrenom($prenom);
        $user->setNom($nom);
        $user->setMail($mail);
        $user->setRoles($roles);
        $user->setActivated($activated);
        $encoded = $this->passwordEncoder->encodePassword($user, $password);
        $user->setPassword($encoded);

        $this->em->persist($user);
        $this->em->flush();
    }

}